#ifndef _ASM_INET_CSUM_H

#define IP_FAST_CSUM(sum, buff, wlen) 					\
		__asm__ ("subqw #1,%2\n"				\
		 "1:\t"							\
		 "movel %1@+,d0\n\t"					\
		 "addxl d0,%0\n\t"					\
		 "dbra %2,1b\n\t"					\
		 "movel %0,d0\n\t"					\
		 "swap d0\n\t"						\
		 "addxw d0,%0\n\t"					\
		 "clrw d0\n\t"						\
		 "addxw d0,%0"						\
		 : "=d" (sum), "=a" (buff), "=d" (wlen)			\
		 : "0" (sum), "1" (buff), "2" (wlen)			\
		 : "d0")

#define IP_COMPUTE_CSUM(sum, buff, len)					\
do {									\
  /* Do the first multiple of 4 bytes and convert to 16 bits. */	\
  if (len > 3)								\
    {									\
      int dummy;							\
      __asm__ ("subql #1,%2\n\t"					\
	       "1:\t"							\
	       "movel %1@+,d0\n\t"					\
	       "addxl d0,%0\n\t"					\
	       "dbra %2,1b\n\t"						\
	       "movel %0,d0\n\t"					\
	       "swap d0\n\t"						\
	       "addxw d0,%0\n\t"					\
	       "clrw d0\n\t"						\
	       "addxw d0,%0"						\
	       : "=d" (sum), "=a" (buff), "=d" (dummy)			\
	       : "0" (sum), "1" (buff), "2" (len >> 2)			\
	       : "d0");							\
    }									\
  if (len & 2)								\
    {									\
      __asm__ ("addw %1@+,%0\n\t"					\
	       "addxw %2,%0"						\
	       : "=d" (sum), "=a" (buff)				\
	       : "d" (0), "0" (sum), "1" (buff));			\
    }									\
  if (len & 1)								\
    {									\
      __asm__ ("movew %1@,d0\n\t"					\
	       "clrb d0\n\t"						\
	       "addw d0,%0\n\t"						\
	       "clrw d0\n\t"						\
	       "addxw d0,%0"						\
	       : "=d" (sum)						\
	       : "a" (buff), "0" (sum)					\
	       : "d0");							\
    }									\
} while (0)

#define TCP_CHECK(sum, saddr, daddr, len, proto, th)			\
do {									\
  __asm__ ("addl %1,%0\n\t"						\
	   "addxl %2,%0\n\t"						\
	   "addxl %3,%0"						\
	   : "=d" (sum)							\
	   : "g" (saddr), "d" (htons (len) + htons (proto)),		\
	     "d" (0), "0" (daddr));					\
  __asm__ ("movel %2,d0\n\t"						\
	   "lsrw #5,d0\n\t"						\
	   "jeq 2f\n\t"							\
	   "subqw #1,d0\n\t"						\
	"1: movel %1@+,d1\n\t"						\
	   "addxl d1,%0\n\t"						\
	   "movel %1@+,d1\n\t"						\
	   "addxl d1,%0\n\t"						\
	   "movel %1@+,d1\n\t"						\
	   "addxl d1,%0\n\t"						\
	   "movel %1@+,d1\n\t"						\
	   "addxl d1,%0\n\t"						\
	   "movel %1@+,d1\n\t"						\
	   "addxl d1,%0\n\t"						\
	   "movel %1@+,d1\n\t"						\
	   "addxl d1,%0\n\t"						\
	   "movel %1@+,d1\n\t"						\
	   "addxl d1,%0\n\t"						\
	   "movel %1@+,d1\n\t"						\
	   "addxl d1,%0\n\t"						\
	   "dbra d0,1b\n\t"						\
	   "addxl %3,%0\n\t"						\
	"2: movel %2,d0\n\t"						\
	   "andw #28,d0\n\t"						\
	   "jeq 4f\n\t"							\
	   "lsrw #2,d0\n\t"						\
	   "subqw #1,d0\n\t"						\
	"3: movel %1@+,d1\n\t"						\
	   "addxl d1,%0\n\t"						\
	   "dbra d0,3b\n\t"						\
	   "addxl %3,%0\n\t"						\
	"4: movel %0,d1\n\t"						\
	   "swap d1\n\t"						\
	   "addw d1,%0\n\t"						\
	   "btst #1,%2\n\t"						\
	   "jeq 5f\n\t"							\
	   "movew %1@+,d1\n\t"						\
	   "addxw d1,%0\n\t"						\
	"5: addxw %3,%0\n\t"						\
	   "btst #0,%2\n\t"						\
	   "jeq 6f\n\t"							\
	   "movew %1@,d1\n\t"						\
	   "clrb d1\n\t"						\
	   "addw d1,%0\n\t"						\
	   "addxw %3,%0\n\t"						\
	"6:"								\
	   : "=d" (sum), "=a" (th)					\
	   : "d" (len), "d" (0), "0" (sum), "1" (th)			\
	   : "d0", "d1");						\
} while (0)

#define UDP_CHECK(sum, saddr, daddr, len, proto, uh)			\
do {									\
  __asm__ ("addl %1,%0\n\t"						\
	   "addxl %2,%0\n\t"						\
	   "addxl %3,%0"						\
	   : "=d" (sum)							\
	   : "g" (saddr), "d" (htons (len) + htons (proto)),		\
	     "d" (0), "0" (daddr));					\
  if (len > 3)								\
    {									\
      int dummy;							\
      __asm__ ("subql #1,%2\n\t"					\
	       "1:\t"							\
	       "movel %1@+,d0\n\t"					\
	       "addxl d0,%0\n\t"					\
	       "dbra %2,1b\n\t"						\
	       "clrl d0; addxl d0,%0"					\
	       : "=d" (sum), "=a" (uh), "=d" (dummy)			\
	       : "0" (sum), "1" (uh), "2" (len >> 2)			\
	       : "d0");							\
    }									\
									\
  /* Convert from 32 bits to 16 bits.  */				\
									\
  __asm__ ("movel %0,d0\n\t"						\
	   "swap d0\n\t"						\
	   "addxw d0,%0\n\t"						\
	   "clrw d0\n\t"						\
	   "addxw d0,%0"						\
	   : "=d" (sum)							\
	   : "0" (sum)							\
	   : "d0");							\
									\
  /* Check for an extra word.  */					\
									\
  if (len & 2)								\
    {									\
      __asm__ ("addw %1@+,%0\n\t"					\
	       "addxw %2,%0"						\
	       : "=d" (sum), "=a" (uh)					\
	       : "d" (0), "0" (sum), "1" (uh));				\
    }									\
									\
  /* Now check for the extra byte.  */					\
									\
  if (len & 1)								\
    {									\
      __asm__ ("movew %1@,d0\n\t"					\
	       "clrb d0\n\t"						\
	       "addw d0,%0\n\t"						\
	       "clrw d0\n\t"						\
	       "addxw d0,%0"						\
	       : "=d" (sum)						\
	       : "a" (uh), "0" (sum)					\
	       : "d0");							\
    }									\
} while (0)

#endif /* _ASM_INET_CSUM_H */

